<template>
  <section class="section-register container">
    <h1>Регистрация</h1>
    <form class="form-register" @submit.prevent="createRegularUser">
      <label>Логин: <input type="email" v-model="user.email" placeholder="regular.user@course-project.ru" required></label>
      <label>Пароль: <input type="password" v-model="user.password" required></label>
      <label>Имя: <input type="text" v-model="user.first_name" placeholder="Иван" required></label>
      <label>Фамилия: <input type="text" v-model="user.last_name" placeholder="Иванов" required></label>
      <label class="border border-dark">Аватарка (необязательно): <input type="file" ref="photo" v-on:change="handlePhotoUpload()"></label>
      <div class="w-100"><input class="btn btn-primary" type="submit" value="Зарегистрироваться"></div>
      <p class="text-danger" v-if="errorMessage">{{this.errorMessage}}</p>
    </form>
  </section>
</template>

<script>
import axios from 'axios'

export default {
  name: "Register",
  data() {
    return {
      user: {
        email: '',
        password: '',
        first_name: '',
        last_name: '',
        photo: ''
      },
      errorMessage: ''
    }
  },
  methods: {
    handlePhotoUpload(){
      this.user.photo = this.$refs.photo.files[0]
    },
    createRegularUser() {
      const formData = new FormData();
      for (const key in this.user) {
        formData.append(key, this.user[key])
      }
      axios
          .post('auth/register/', formData, {
            headers: {
              'Content-Type': 'multipart/form-data'
            }
          })
          .then(response => {
            this.$router.push('/login')
            console.log(response)
          })
          .catch(({response: {data: {email: errorMessage}}}) => {
            this.errorMessage = errorMessage.join(' ')
          })
    }
  }
}
</script>

<style scoped>
.form-register {
  display: flex;
  flex-wrap: wrap;
  gap: 8px;
  justify-content: center;
}
</style>